#!/usr/bin/python3


import os
import sys
import signal
import locale
import gettext
import json

VERSION = 'v2024.5.7'
pkgdatadir = '/usr/share/varia'
localedir = '/usr/share/locale'

sys.path.insert(1, pkgdatadir)
signal.signal(signal.SIGINT, signal.SIG_DFL)
gettext.install('varia', localedir)

aria2cexec = sys.argv[1]

try:
	locale.bindtextdomain('varia', localedir)
	locale.textdomain('varia')
except:
	print('Cannot set locale.')
try:
	gettext.bindtextdomain('varia', localedir)
	gettext.textdomain('varia')
except:
	print('Cannot load translations.')

if __name__ == '__main__':
	mymodule_dir = os.path.join(pkgdatadir, 'varia')
	sys.path.append( mymodule_dir )
	from variamain import main
	sys.exit(main(VERSION, aria2cexec))
